static	char	sccsid[]="%Z% %M% %I% %E% %U%";
/*******************************************************/
/* <clprbreak.c>                                       */
/*      break process   @@@                         */
/*******************************************************/

#include "colmn.h"

/************************************/
/*									*/
/************************************/
static int _push_break(leaf,proc,n)
Leaf   *leaf;
ProcCT *proc;
int n;
{
	static char	retprm[16];
	static Leaf	Retleaf;
	static parmList Retprmlist,*Wprmp[2];
	Leaf	*retleaf;
	parmList *retprmlist,**wprmp;

	retleaf = &Retleaf;
	retprmlist = &Retprmlist;
	wprmp = Wprmp;
	memcpy(retleaf,leaf,sizeof(Leaf));
	retleaf->rightleaf = NULL;
	retleaf->leftleaf  = NULL;
	cl_copy_cmd(&(retleaf->cmd),&(leaf->cmd));
	retleaf->cmd.prmp = wprmp;
	sprintf(retprm,"%d",n);
	retleaf->cmd.prmp[0]= retprmlist;
	retprmlist->prmlen  = strlen(retprm);
	retprmlist->prp     = retprm;
	retprmlist->opt     = D_GX_OPT_NO_USE_OBJ;
	cl_ret_leaf_push(proc,retleaf);
	return 0;
}

/************************************/
/*									*/
/************************************/
int cl_pop_finally(proc,pcrLCB)
ProcCT *proc;
BlockCB *pcrLCB;
{
	static int try_cida[]={C_CATCH,C_FINALLY,C_ENDTRY,0};
	Leaf    *leafw;

	if (!(leafw=cl_ret_leaf_pop_search(proc,try_cida,3))) return -1;
	while (leafw) {
		if (leafw->cmd.cid == C_FINALLY) {
			proc->pcrBlockCB = pcrLCB;
			proc->Nextleaf = leafw;
			return C_FINALLY;
		}
		leafw=leafw->rightleaf;
	}
	/* OTRYԂɖ߂ */
	proc->pFlag = pcrLCB->pFlag;
	proc->ucExcept = pcrLCB->ucExcept;
	return 0;
}

/************************************/
/* _check_in_loop					*/
/************************************/
static int _check_in_loop(proc)
ProcCT  *proc;
{
	if (!cmn_chk_stat(LOP_PR,&proc->ptype)) {
		ERROROUT("Outside of loop !!");
		return ECL_SCRIPT_ERROR;
	}
	return 0;
}

/************************************/
/* _set_up_level					*/
/************************************/
static int _set_up_level(leaf, proc, ip, msg, err)
Leaf    *leaf;
ProcCT  *proc;
int      ip;
char    *msg;
int      err;
{
	int rc,level,n,cid;
	BlockCB *pcrLCB;

	if (leaf->cmd.prmnum > ip) {
		rc = cl_get_gx_exp_bin(leaf->cmd.prmnum-ip,&(leaf->cmd.prmp[ip]),proc->Obj,
		                   &level,0x01,msg,err);
		if (rc) {
			if (rc == ECL_NULL_DATA) level = 1;
			else return rc;
		}
/*
printf("_set_up_level: level=%d\n",level);
*/
		if (level < 0) {
			ERROROUT2(FORMAT(411),msg,level);	/* %sx(%d)słB */
			return err;
		}
		else if (!level) return C_SKIP_COMMAND;
	}
	else level = 1;

	pcrLCB = proc->pcrBlockCB;
	for (n=level;;) {
		if (!pcrLCB) {
			ERROROUT2(FORMAT(412),msg,level);	/* %sx(%d)I[ołB */
			return err;
		}
/*
printf("_set_up_level: cid=%08x\n",pcrLCB->cid);
*/
		if ((cid=pcrLCB->cid)==C_TRY) {
			rc = cl_pop_finally(proc,pcrLCB);
			if (rc) {
				if (rc == C_FINALLY) {
					_push_break(leaf,proc,n);
				}
				return rc;
			}
		}
		else if (cid==C_LOOP || cid==C_FOR || cid==C_DO) {
			if (--n <= 0) break;
		}
		pcrLCB->iUsed = 0;
		pcrLCB = pcrLCB->preBlockCB;
	}
	proc->pcrBlockCB = pcrLCB;
	return 0;
}

/************************************/
/* cl_process_break                 */
/************************************/
int cl_process_break(leaf, proc)
Leaf    *leaf;
ProcCT  *proc;
{
	int rc,level;

	if (!leaf || !proc) return ECL_SYSTEM_ERROR;

	rc = _check_in_loop(proc);
	if (!rc) {
		rc = _set_up_level(leaf,proc,0,"cl_process_break: ",ECL_EX_BREAK);
		if (!rc) {
			proc->pcrBlockCB->iLoopCounter = 0x7ffffffe;
			cmn_set_stat(BRK_PR,&proc->ptype,L_ON);
			rc = cl_set_continue(leaf,proc);
		}
		else if (rc == C_SKIP_COMMAND) rc = 0;
		else if (rc == C_FINALLY) {
			cmn_set_stat(BRK_PR,&proc->ptype,L_ON);
			rc = 0;
		}
	}
	return rc;
}

/************************************/
/* cl_set_continue					*/
/************************************/
int cl_set_continue(leaf,proc)
Leaf    *leaf;
ProcCT  *proc;
{
	int rc;
	BlockCB *pcrLCB;
	Leaf   *loop_leaf,*leafw;

	loop_leaf = NULL;
	if (pcrLCB=proc->pcrBlockCB) {
		if (pcrLCB->iUsed) loop_leaf = pcrLCB->Blockleaf;
	}
/*
printf("CONTINUE: pcrLCB=%08x loop_leaf=%08x\n",pcrLCB,loop_leaf);
*/
	if (loop_leaf) {
		while (leafw=cl_ret_leaf_pop(proc)) {
/*
printf("CONTINUE: leafw=%08x\n",leafw);
*/
			if (leafw == loop_leaf) break;
		}
		if (leafw) {
			proc->Nextleaf = loop_leaf;
DEBUGOUTL1(190,"cl_set_continue: found leaf=%08x",loop_leaf);
			rc = 0;
		}
		else rc = ECL_SYSTEM_ERROR;
	}
	else rc = ECL_SYSTEM_ERROR;
	return rc;
}

/************************************/
/* cl_process_continue                */
/************************************/
int cl_process_continue(leaf, proc)
Leaf    *leaf;
ProcCT  *proc;
{
	return cl_pr_continue(leaf,proc,0);
}

/************************************/
/* cl_pr_continue						*/
/************************************/
int cl_pr_continue(leaf, proc, ip)
Leaf    *leaf;
ProcCT  *proc;
int      ip;
{
	int rc;

	if (leaf && proc) {
		rc = _check_in_loop(proc);
		if (!rc) {
			rc = _set_up_level(leaf,proc,ip,"cl_pr_continue: ",ECL_EX_CONTINUE);
			if (!rc) rc = cl_set_continue(leaf,proc);
 			else if (rc == C_SKIP_COMMAND) rc = 0;
			else if (rc == C_FINALLY) {
				cmn_set_stat(BRK_PR,&proc->ptype,L_ON);
				rc = 0;
			}
		}
	}
	else rc = ECL_SYSTEM_ERROR;

	return rc;
}
